local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local ____exports = {}
local ____isaac_2Dtypescript_2Ddefinitions = require("isaac-typescript-definitions")
local ModCallback = ____isaac_2Dtypescript_2Ddefinitions.ModCallback
local ____CustomCallback = require("classes.private.CustomCallback")
local CustomCallback = ____CustomCallback.CustomCallback
____exports.InputActionFilter = __TS__Class()
local InputActionFilter = ____exports.InputActionFilter
InputActionFilter.name = "InputActionFilter"
__TS__ClassExtends(InputActionFilter, CustomCallback)
function InputActionFilter.prototype.____constructor(self)
    CustomCallback.prototype.____constructor(self)
    self.shouldFire = function(____, fireArgs, optionalArgs)
        local _entity, inputHook, buttonAction = table.unpack(fireArgs)
        local callbackInputHook, callbackButtonAction = table.unpack(optionalArgs)
        return (callbackInputHook == nil or callbackInputHook == inputHook) and (callbackButtonAction == nil or callbackButtonAction == buttonAction)
    end
    self.inputAction = function(____, entity, inputHook, buttonAction) return self:fire(entity, inputHook, buttonAction) end
    self.callbacksUsed = {{ModCallback.INPUT_ACTION, self.inputAction}}
end
return ____exports
